'From etoys2.2 of 1 October 2007 [latest update: #1675] on 20 January 2008 at 9:53:22 pm'!
"Change Set:		FunTowers
Date:			20 January 2008
Author:			Robert Krahn

Authors: Benjamin Johannes Dyck, Matthias Richly, Marcus Wacke, Maximilian Jenders, Robert Gurol, Thomas Beyhl, Johannes Koehler

Hasso-Plattner-Institut
Software Architecture Group
http://www.hpi.uni-potsdam.de/swa/


Funtowers is a singleplayer card game.
Your goal is to clear all card-towers on the playflield. To be able to remove a card from a tower, its value must be one greater or one smaller than the value of the card on the deposit stack. If there is no matching card, you can pull another one from the draw stack. But remember that you do not have unlimited cards to pull!! There is also a time limit, so do not take to much time for every move. You lose, if the time is out or if the draw stack is empty and no cards from the field can be removed any more.

How to start the game:

- open a Workspace
- type FtGame create
- Yellow-Click on the text and choose Do-It
	or:
- from World menu choose new Morph... --> 'from alphabetical list' --> Letter F --> FtGame
	or:
- open the objects tool
- you find Funtowers in the games section.

How to play:

- everything is done with the mouse:
	- to remove a card from a tower, just click on it
	- to draw a new card from the draw stack, click on the stack

Have Fun!!

License:

This Game is provided under the MIT-License:

Copyright (c) <2007> <Johannes Dyck, Matthias Richly, Marcus Wacke, Maximilian Jenders, Robert Gurol, Thomas Beyhl, Johannes Koehler>

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the 'Software'), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE."!

Morph subclass: #FtCardFieldMorph
	instanceVariableNames: 'cardHolders'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Funtowers-Game'!

!FtCardFieldMorph commentStamp: 'MR 7/17/2007 13:54' prior: 0!
I hold the cardholders and arrange them in the given layout (e.g. 3 towers).

Instance Variables
	cardHolders:		collection

cardHolders
	- 2-dimensional collection structuring the cardholders in rows and columns!

Morph subclass: #FtCardHolderMorph
	instanceVariableNames: 'topL topR bottomL bottomR'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Funtowers-Game'!

!FtCardHolderMorph commentStamp: 'MR 7/17/2007 13:58' prior: 0!
I can hold exactly one card. My task is to manage the needed connections between the cards on the field.

Instance Variables
	bottomL:	FtCardHolderMorph
	bottomR:	FtCardHolderMorph
	topL:		FtCardHolderMorph
	topR:		FtCardHolderMorph

bottomL: reference to the cardholder button left
bottomR: reference to the cardholder button right
topL: reference to the cardholder top left
topR: reference to the cardholder top right!

ImageMorph subclass: #FtCardMorph
	instanceVariableNames: 'cardValue cardColor side'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Funtowers-Game'!

!FtCardMorph commentStamp: 'MR 7/17/2007 14:00' prior: 0!
I represent a card of the game.

Instance Variables
	cardColor:	string
	cardValue:	string
	side:		symbol

side
	- the current side, the card is showing (#front or #back)
!

ImageMorph subclass: #FtCardStackMorph
	instanceVariableNames: 'cardDisplacement'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Funtowers-Game'!

!FtCardStackMorph commentStamp: 'MR 7/17/2007 14:01' prior: 0!
I represent a card stack.

Instance Variables
	cardDisplacement:		aNumber

cardDisplacement
	- every card is displaced relative to its underlaying card by this value to achieve a 3D-effect
!

FtCardStackMorph subclass: #FtCardDrawStackMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Funtowers-Game'!

!FtCardDrawStackMorph commentStamp: 'MR 7/17/2007 13:47' prior: 0!
I am a spezialisation of FtCardStackMorph, who can handle mouse clicks.!

RectangleMorph subclass: #FtCountDownTimerMorph
	instanceVariableNames: 'secondsToCountDown remainingSeconds isRunning colorTable fullWidth'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Funtowers-Game'!

!FtCountDownTimerMorph commentStamp: 'MR 7/17/2007 14:07' prior: 0!
I am a countdown timer. My length represents the time left on the timer, thus I shrink, when the time counts down. I also change my color from green to red while shrinking.

Instance Variables
	colorTable:		an OrderedCollection
	fullWidth:		anInteger
	isRunning:		a Boolean
	remainingSeconds:		anInterger
	secondsToCountDown:	anInterger

colorTable
	- one color for every possible state of the timer (every value remainingSeconds can get)

fullWidth
	- the width of the morph, when remainingSeconds = secondsToCountDown

isRunning
	- true if the timer is running

remainingSeconds
	- how many seconds are left to 0

secondsToCountDown
	- how many seconds should it count down totally
!

ImageMorph subclass: #FtGame
	instanceVariableNames: 'cardField drawStack depositStack startButton stopButton scoreCounter timer gameIsRunning cardFieldTowersRemoved'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Funtowers-Game'!

!FtGame commentStamp: 'MR 7/17/2007 14:16' prior: 0!
I am the game. Game elements are my submorphs. I handle the game events.

Instance Variables
	cardField:				<FtCardFieldMorph>
	cardFieldTowersRemoved:<Integer>
	depositStack:			<FtCardStackMorph>
	drawStack:				<FtCardDrawStackMorph>
	gameIsRunning:			<Boolean>
	scoreCounter:			<FtScoreCountMorph>
	startButton:				<ThreePhaseButtonMorph>
	stopButton:				<ThreePhaseButtonMorph>
	timer:					<FtCountDownTimerMorph>

gameIsRunning
	- true, if the game is running

cardFieldTowersRemoved
	- number of towers removed during the currently running game!

Object subclass: #FtResourceManager
	instanceVariableNames: 'resources'
	classVariableNames: 'SoleInstance'
	poolDictionaries: ''
	category: 'Funtowers-Game'!

!FtResourceManager commentStamp: 'MR 7/17/2007 14:08' prior: 0!
I load all needed game-resources. I am a Singleton!!

Class Variables
	SoleInsatnce:	<FtResourceManager> my unigue instance

Instance Variables
	resources:		<Dictionary (filename -> resource)>!

StringMorph subclass: #FtScoreCountMorph
	instanceVariableNames: 'score'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Funtowers-Game'!

!FtScoreCountMorph commentStamp: 'MR 7/17/2007 14:09' prior: 0!
I count the points achieved in the game.

Instance Variables
	score:		integer

score
	- the current score
!


!FtCardFieldMorph methodsFor: 'accessing' stamp: 'MR 6/28/2007 15:46'!
numberOfTowers
"return the number of cardholders with no cardholders above (the peaks of a tower)"

	| result |
	result := 0.
	self cardHoldersDo: [:each |
		(each isTop)
		ifTrue: [result := result + 1]
		].
	^ result! !

!FtCardFieldMorph methodsFor: 'accessing - private' stamp: 'MR 7/17/2007 11:07'!
cardHolders
	
	^ cardHolders! !

!FtCardFieldMorph methodsFor: 'accessing - private' stamp: 'MR 7/17/2007 11:07'!
cardHolders: aCollection

	cardHolders := aCollection! !

!FtCardFieldMorph methodsFor: 'enumenrating - private' stamp: 'MR 7/17/2007 11:11'!
cardHoldersDoWithIndex: aBlock
"enumerate over all cardHolders and also get the indexes of the cardHolders in the 2-dimensional Collection"

	1 to: self cardHolders size do: [:row |
		1 to: (self cardHolders at: row) size do: [:element | 
			((self cardHolders at: row) at: element)
			ifNotNil: [
				aBlock value: ((self cardHolders at: row) at: element) value: row value: element
				]
			]
		]
	! !

!FtCardFieldMorph methodsFor: 'enumerating' stamp: 'MR 7/17/2007 11:12'!
cardHoldersDo: aBlock
"enumerate over all cardHolders"

	1 to: self cardHolders size do: [:i |
		1 to: (self cardHolders at: i) size do: [:j | 
			((self cardHolders at: i) at: j)
			ifNotNil: [
				aBlock value: ((self cardHolders at: i) at: j)
				]
			]
		]
	! !

!FtCardFieldMorph methodsFor: 'enumerating' stamp: 'JoKer 6/19/2007 17:53'!
cardHoldersWithCardFaceUpDo: aBlock
"enumerate over all cardHolders, that hold a card and whose card shows front"

	self cardHoldersDo: [:holder | 
		(holder holdsCard and: [holder card showsFront])
		ifTrue: [aBlock value: holder]
		]! !

!FtCardFieldMorph methodsFor: 'initialization' stamp: 'MR 5/17/2007 16:07'!
initialize

	self initializeWith: FtGame cardFieldLayout! !

!FtCardFieldMorph methodsFor: 'initialization' stamp: 'MR 7/17/2007 11:23'!
initializeWith: aCardFieldLayout

	super initialize.
	
	self color: Color transparent;
		createCardHolders: aCardFieldLayout;
		initializeCardHolders;
		height: self neededHeight;
		width: self neededWidth;
		positionCardHolders;
		addCardHoldersAsSubmorphs! !

!FtCardFieldMorph methodsFor: 'private' stamp: 'MR 5/24/2007 18:14'!
addCardHoldersAsSubmorphs

	self cardHoldersDo: [:each |
		self addMorph: each
		]! !

!FtCardFieldMorph methodsFor: 'private' stamp: 'MR 7/17/2007 11:15'!
createCardHolders: aCardFieldLayout
"create the needed cardholders for the given layout and add them to the collection"

	self cardHolders: (Array new: aCardFieldLayout size).
	1 to: aCardFieldLayout size do: [:i |
		self cardHolders at: i put: (Array new: (aCardFieldLayout at: i) size).
		1 to: (aCardFieldLayout at: i) size do: [:j |
			(((aCardFieldLayout at: i) at: j) = 1)
			ifTrue: [(self cardHolders at: i) at: j put: (FtCardHolderMorph new)]
			]
		]
	! !

!FtCardFieldMorph methodsFor: 'private' stamp: 'MR 7/4/2007 15:10'!
horizontalSpace
"horizontal space between the cardholders (negative, if they should overlap)"

	^ -15! !

!FtCardFieldMorph methodsFor: 'private' stamp: 'MR 7/17/2007 11:18'!
initializeCardHolders
"set the cardholders topL,topR,bottomL,bottomR properties"	
	
	self cardHoldersDoWithIndex: [:each :i :j |
		(i = 1) 
		ifFalse: [
			(j = 1) 
			ifFalse: [each topL: ((self cardHolders at: i - 1) at: j - 1)].
			(j = (self cardHolders at: i) size)
			 ifFalse: [each topR: ((self cardHolders at: i - 1) at: j)] 
			].
		(i = self cardHolders size) 
		ifFalse: [
			each bottomL: ((self cardHolders at: i + 1) at: j).
			each bottomR: ((self cardHolders at: i + 1) at: j + 1) 
			]
		]
	! !

!FtCardFieldMorph methodsFor: 'private' stamp: 'MR 7/17/2007 11:20'!
maxRowsLength
"return the length of the longest row in the field"

	| result |
	result := 0.
	self cardHolders do: [:row | (result < row size) ifTrue: [result := row size]].
	^ result! !

!FtCardFieldMorph methodsFor: 'private' stamp: 'MR 7/17/2007 11:21'!
neededHeight

	^ (FtGame cardHeight * cardHolders size) + (self horizontalSpace * (cardHolders size - 1)).! !

!FtCardFieldMorph methodsFor: 'private' stamp: 'MR 7/17/2007 11:22'!
neededWidth

	^ (FtGame cardWidth * self maxRowsLength) + (self verticalSpace * (self maxRowsLength - 1)).! !

!FtCardFieldMorph methodsFor: 'private' stamp: 'MR 7/17/2007 11:20'!
positionCardHolders
"set the position of all the cardholders"

	self cardHoldersDoWithIndex: [:each :i :j | | top left leftstart |
		top := (i - 1) * (FtGame cardHeight + self horizontalSpace) + self top.
		leftstart := (self maxRowsLength - (self cardHolders at: i) size) * FtGame cardWidth / 2.
		left := leftstart + ((j - 1)*(FtGame cardWidth + self verticalSpace)) + self left.
		each position: left@top
		]
	! !

!FtCardFieldMorph methodsFor: 'private' stamp: 'MR 7/4/2007 15:05'!
verticalSpace
"vertical space between the cardholders"

	^ 2! !


!FtCardFieldMorph class methodsFor: 'instance creation' stamp: 'MR 5/17/2007 14:29'!
with: aCardFieldLayout

	^ self basicNew initializeWith: aCardFieldLayout! !


!FtCardHolderMorph methodsFor: 'accessing' stamp: 'JoKer 6/19/2007 17:17'!
bottomL

	^ bottomL! !

!FtCardHolderMorph methodsFor: 'accessing' stamp: 'JoKer 6/19/2007 17:17'!
bottomL: aFtCardHolderMorph

	bottomL := aFtCardHolderMorph! !

!FtCardHolderMorph methodsFor: 'accessing' stamp: 'JoKer 6/19/2007 17:18'!
bottomR

	^ bottomR! !

!FtCardHolderMorph methodsFor: 'accessing' stamp: 'JoKer 6/19/2007 17:18'!
bottomR: aFtCardHolderMorph

	bottomR := aFtCardHolderMorph! !

!FtCardHolderMorph methodsFor: 'accessing' stamp: 'MR 6/28/2007 16:02'!
gameControl
"return a reference to the game controlling object"

	^ self ownerThatIsA: FtGame! !

!FtCardHolderMorph methodsFor: 'accessing' stamp: 'MR 7/17/2007 11:25'!
isTop
"answer true, if the holder is a top of a tower"

	^ (self topL isNil and: [self topR isNil])! !

!FtCardHolderMorph methodsFor: 'accessing' stamp: 'JoKer 6/19/2007 17:30'!
topL

	^ topL! !

!FtCardHolderMorph methodsFor: 'accessing' stamp: 'JoKer 6/19/2007 17:30'!
topL: aFtCardHolderMorph

	topL := aFtCardHolderMorph! !

!FtCardHolderMorph methodsFor: 'accessing' stamp: 'JoKer 6/19/2007 17:31'!
topR

	^ topR! !

!FtCardHolderMorph methodsFor: 'accessing' stamp: 'JoKer 6/19/2007 17:31'!
topR: aFtCardHolderMorph

	topR := aFtCardHolderMorph! !

!FtCardHolderMorph methodsFor: 'card accessing' stamp: 'MR 6/30/2007 10:45'!
addCard: aFtCardMorph
"set the card the holder should hold. if it already holds a card, give an error"

	(self holdsCard)
	ifTrue: [self error: 'This cardHolder is occupied']
	ifFalse: [self addMorphCentered: aFtCardMorph]! !

!FtCardHolderMorph methodsFor: 'card accessing' stamp: 'MR 6/28/2007 16:02'!
card
"return the card hold from this holder or nil, if no card is present"

	(self holdsCard)
	ifTrue: [^ self firstSubmorph]
	ifFalse: [^ nil]! !

!FtCardHolderMorph methodsFor: 'card accessing' stamp: 'MR 5/21/2007 19:11'!
holdsCard

	^ self hasSubmorphs! !

!FtCardHolderMorph methodsFor: 'card accessing' stamp: 'MR 7/17/2007 11:25'!
removeCard
"explicitly remove the card from this cardHolder and return it"

	| card |
	(self holdsCard)
	ifTrue: [
		card := self card.
		self removeMorph: card.
		(self topL isNil) ifFalse: [self topL setCardSide].
		(self topR isNil) ifFalse: [self topR setCardSide].
		^ card
		]
	ifFalse: [self error: 'No card present']! !

!FtCardHolderMorph methodsFor: 'card accessing' stamp: 'MR 7/17/2007 11:27'!
setCardSide
"if there are no holders below this one, or do the holders below hold no card, then turn the card held to the frontside, otherwise to the backside"

	(self holdsCard)
	ifTrue: [
		((self bottomL isNil and: [self bottomR isNil]) 
			or: [self bottomL holdsCard not and: [self bottomR holdsCard not]])
		ifTrue: [self card turnToFront]
		ifFalse: [self card turnToBack]
		]! !

!FtCardHolderMorph methodsFor: 'event handling' stamp: 'MR 5/23/2007 17:15'!
handlesMouseDown: evt

	^ true.! !

!FtCardHolderMorph methodsFor: 'event handling' stamp: 'MR 5/26/2007 09:35'!
mouseDown: evt

	(evt redButtonPressed)
	ifTrue: [ 
		self gameControl cardHolderClick: self
		]! !

!FtCardHolderMorph methodsFor: 'initialization' stamp: 'MR 6/28/2007 15:37'!
initialize

	super initialize.
	
	self color: Color transparent;
		height: FtGame cardHeight;
		width: FtGame cardWidth.! !


!FtCardMorph methodsFor: 'accessing' stamp: 'JoKer 6/19/2007 17:38'!
antecessor
"return the antecessor of the card depending on its value"

	| index |
	index := (FtGame cardValues findFirst: [:v | v = self cardValue]).
	^ FtGame cardValuesAntecessores at: index! !

!FtCardMorph methodsFor: 'accessing' stamp: 'rkrk 1/20/2008 21:34'!
back
"return a form showing the backside of the card"

	^ FtResourceManager at: 'card_back.jpg'! !

!FtCardMorph methodsFor: 'accessing' stamp: 'MR 5/17/2007 11:12'!
cardColor

	^ cardColor! !

!FtCardMorph methodsFor: 'accessing' stamp: 'MR 5/17/2007 11:11'!
cardValue

	^ cardValue! !

!FtCardMorph methodsFor: 'accessing' stamp: 'rkrk 1/20/2008 21:34'!
front
"return a form showing the frontside of the card"

	^ FtResourceManager at: (cardColor,'_', cardValue,'.jpg')! !

!FtCardMorph methodsFor: 'accessing' stamp: 'MR 5/23/2007 17:19'!
isAntecessorOf: aFtCardMorph

	^ (self successor = aFtCardMorph cardValue)! !

!FtCardMorph methodsFor: 'accessing' stamp: 'MR 6/9/2007 20:35'!
isNeighborOf: aFtCardMorph

	^ ((self isAntecessorOf: aFtCardMorph) or: [self isSuccessorOf: aFtCardMorph])! !

!FtCardMorph methodsFor: 'accessing' stamp: 'MR 5/23/2007 17:20'!
isSuccessorOf: aFtCardMorph

	^ (self antecessor = aFtCardMorph cardValue)! !

!FtCardMorph methodsFor: 'accessing' stamp: 'MR 7/17/2007 11:28'!
side
	"Answer the value of side"

	^ side! !

!FtCardMorph methodsFor: 'accessing' stamp: 'JoKer 6/19/2007 17:37'!
successor
"return the successor of the card depending on its value"

	| index |
	index := (FtGame cardValues findFirst: [:v | v = self cardValue]).
	^ FtGame cardValuesSuccessores at: index! !

!FtCardMorph methodsFor: 'accessing - private' stamp: 'MR 7/17/2007 11:30'!
cardColor: aCardColor

	cardColor := aCardColor! !

!FtCardMorph methodsFor: 'accessing - private' stamp: 'MR 7/17/2007 11:31'!
cardValue: aCardValue

	cardValue := aCardValue! !

!FtCardMorph methodsFor: 'accessing - private' stamp: 'MR 7/17/2007 11:31'!
side: aSymbol

	side := aSymbol! !

!FtCardMorph methodsFor: 'initialization' stamp: 'MR 6/16/2007 10:50'!
initialize

	self initializeWithValue: '10' color: 'fire'! !

!FtCardMorph methodsFor: 'initialization' stamp: 'MR 7/17/2007 11:32'!
initializeWithValue: aCardValue color: aCardColor

	super initialize.
	
	self cardValue: aCardValue;
		 cardColor: aCardColor;
		 side: #back;
		 newForm: self back.! !

!FtCardMorph methodsFor: 'turning' stamp: 'MR 7/17/2007 11:34'!
showsBack
	
	^ (self side = #back)! !

!FtCardMorph methodsFor: 'turning' stamp: 'MR 7/17/2007 11:34'!
showsFront
	
	^ (self side = #front)! !

!FtCardMorph methodsFor: 'turning' stamp: 'MR 7/17/2007 11:33'!
turn
"flip the card from back to front or vice versa"

	(self showsBack)
	ifTrue: [self turnToFront]
	ifFalse: [self turnToBack]! !

!FtCardMorph methodsFor: 'turning' stamp: 'MR 7/17/2007 11:34'!
turnToBack
"let the card show its backside"

	self newForm: self back;
		side: #back! !

!FtCardMorph methodsFor: 'turning' stamp: 'MR 7/17/2007 11:35'!
turnToFront
"let the card show its frontside"

	self newForm: self front;
		side: #front! !


!FtCardMorph class methodsFor: 'instance creation' stamp: 'MR 6/28/2007 16:00'!
withValue: aCardValue color: aCardColor
"create a new card with the spezified color and value"

	^ self basicNew initializeWithValue: aCardValue color: aCardColor! !


!FtCardStackMorph methodsFor: 'accessing' stamp: 'MR 7/4/2007 14:42'!
add: aCardMorph
"add a card on the top of the stack"

	(self isEmpty)
	ifTrue: [aCardMorph position: self position]
	ifFalse: [aCardMorph position: (self top position) - self cardDisplacement].
	self addMorph: aCardMorph! !

!FtCardStackMorph methodsFor: 'accessing' stamp: 'rkrk 1/20/2008 21:33'!
background
"return a form showing the background of the stack"

	^ FtResourceManager at: 'cardstack_empty.jpg'! !

!FtCardStackMorph methodsFor: 'accessing' stamp: 'MR 5/17/2007 11:53'!
cardDisplacement

	^ cardDisplacement! !

!FtCardStackMorph methodsFor: 'accessing' stamp: 'MR 6/28/2007 15:39'!
cardDisplacement: aNumber

	cardDisplacement := aNumber.
	self update! !

!FtCardStackMorph methodsFor: 'accessing' stamp: 'MR 7/4/2007 14:41'!
defaultCardDisplacement

	^ 0.5! !

!FtCardStackMorph methodsFor: 'accessing' stamp: 'MR 5/17/2007 12:03'!
isEmpty

	^ (self size = 0)! !

!FtCardStackMorph methodsFor: 'accessing' stamp: 'MR 7/1/2007 10:11'!
removeTop
"remove the card on the top from the stack and return it"

	| topCard |
	(self isEmpty)
	ifFalse: [
		topCard _ self top.
		self removeMorph: topCard.
		^ topCard]
	ifTrue: [self error: 'CardStack does not contain any cards!!']! !

!FtCardStackMorph methodsFor: 'accessing' stamp: 'MR 6/28/2007 15:40'!
shuffle
"shuffle the stack"

	(self isEmpty)
	ifFalse: [
		self shuffleSubmorphs;
			update
	]! !

!FtCardStackMorph methodsFor: 'accessing' stamp: 'JoKer 6/19/2007 17:39'!
size
"answer how many card are on the stack"

	^ self submorphCount! !

!FtCardStackMorph methodsFor: 'accessing' stamp: 'JoKer 6/19/2007 17:39'!
top
"return the card on the top of the stack"

	(self isEmpty)
	ifFalse: [^ self firstSubmorph]
	ifTrue: [self error: 'CardStack does not contain any cards!!'. ^ nil]! !

!FtCardStackMorph methodsFor: 'initialization' stamp: 'MR 6/28/2007 15:41'!
initialize
	
	super initialize.
	self newForm: self background;
		cardDisplacement: self defaultCardDisplacement! !

!FtCardStackMorph methodsFor: 'private' stamp: 'MR 7/4/2007 14:41'!
update
"reposition the cards of the stack with the current cardDisplacement, e.g. after shuffling the stack"

	(self isEmpty)
	ifFalse: [
		self lastSubmorph position: self position.
		self submorphsReverseDo: 
			[:each | 
			(each == self lastSubmorph) 	
				ifFalse: 
				[each position: (each submorphAfter position - self cardDisplacement)]
			]
		]! !


!FtCardDrawStackMorph methodsFor: 'accessing' stamp: 'JoKer 6/19/2007 17:52'!
gameControl
"return a reference to the game controlling object"

	^ self ownerThatIsA: FtGame! !

!FtCardDrawStackMorph methodsFor: 'event handling' stamp: 'MR 5/23/2007 15:26'!
handlesMouseDown: evt

	^ true.! !

!FtCardDrawStackMorph methodsFor: 'event handling' stamp: 'MR 5/26/2007 09:25'!
mouseDown: evt

	(evt redButtonPressed)
	ifTrue: [
		self gameControl drawStackClick: self.
		]! !


!FtCountDownTimerMorph methodsFor: 'accessing' stamp: 'MR 6/9/2007 17:13'!
defaultHeight

	^ 20! !

!FtCountDownTimerMorph methodsFor: 'accessing' stamp: 'MR 6/9/2007 17:11'!
defaultWidth

	^ 700! !

!FtCountDownTimerMorph methodsFor: 'accessing' stamp: 'MR 6/8/2007 10:20'!
fullWidth

	^ fullWidth! !

!FtCountDownTimerMorph methodsFor: 'accessing' stamp: 'JoKer 6/19/2007 17:40'!
fullWidth: anInteger
"set a new value for the maximum width of the bar"

	fullWidth := anInteger.
	self update! !

!FtCountDownTimerMorph methodsFor: 'accessing' stamp: 'JoKer 6/19/2007 17:40'!
gameControl
"return a reference to the game controlling object"

	^ self ownerThatIsA: FtGame! !

!FtCountDownTimerMorph methodsFor: 'accessing' stamp: 'MR 5/27/2007 10:06'!
isRunning

	^ isRunning! !

!FtCountDownTimerMorph methodsFor: 'accessing' stamp: 'MR 5/5/2007 14:13'!
isTimedOut

	^ (remainingSeconds = 0)! !

!FtCountDownTimerMorph methodsFor: 'accessing' stamp: 'MR 6/8/2007 10:23'!
remainingSeconds

	^ remainingSeconds! !

!FtCountDownTimerMorph methodsFor: 'accessing' stamp: 'MR 6/6/2007 18:25'!
remainingSeconds: numberOfSeconds

	remainingSeconds := numberOfSeconds.
	self update! !

!FtCountDownTimerMorph methodsFor: 'accessing' stamp: 'MR 6/8/2007 10:23'!
secondsToCountDown

	^ secondsToCountDown! !

!FtCountDownTimerMorph methodsFor: 'accessing' stamp: 'MR 6/8/2007 10:30'!
secondsToCountDown: numberOfSeconds

	secondsToCountDown := numberOfSeconds.
	self generateColorTable.
	self update! !

!FtCountDownTimerMorph methodsFor: 'accessing - private' stamp: 'MR 7/17/2007 11:38'!
colorTable

	^ colorTable! !

!FtCountDownTimerMorph methodsFor: 'accessing - private' stamp: 'MR 7/17/2007 11:39'!
colorTable: aCollection

	colorTable := aCollection! !

!FtCountDownTimerMorph methodsFor: 'accessing - private' stamp: 'MR 7/17/2007 11:38'!
isRunning: aBoolean

	isRunning := aBoolean! !

!FtCountDownTimerMorph methodsFor: 'initialization' stamp: 'MR 6/6/2007 17:51'!
initialize

	^ self initializeWith: 60! !

!FtCountDownTimerMorph methodsFor: 'initialization' stamp: 'MR 7/17/2007 11:54'!
initializeWith: aNumberOfSecondsToCountDown

	super initialize.
	
	self borderWidth: 0;
		height: self defaultHeight.
	remainingSeconds _ secondsToCountDown _ aNumberOfSecondsToCountDown.
	self generateColorTable;
		fullWidth: self defaultWidth;
		update;
		stop! !

!FtCountDownTimerMorph methodsFor: 'stepping and presenter' stamp: 'MR 7/17/2007 11:44'!
step

	(self isRunning and: [self remainingSeconds > 0])
	ifTrue: [self remainingSeconds: self remainingSeconds -1.
			self update.
			
			(self isTimedOut)
			ifTrue: [self gameControl timerTimeout]
			]! !

!FtCountDownTimerMorph methodsFor: 'stepping and presenter' stamp: 'MR 5/5/2007 14:25'!
stepTime

	^ 1000! !

!FtCountDownTimerMorph methodsFor: 'timer' stamp: 'MR 7/17/2007 11:45'!
reset

	self stop;
		remainingSeconds: self secondsToCountDown;
		update! !

!FtCountDownTimerMorph methodsFor: 'timer' stamp: 'MR 6/28/2007 15:49'!
resetAndStart

	self reset;
		start! !

!FtCountDownTimerMorph methodsFor: 'timer' stamp: 'MR 7/17/2007 11:45'!
start
"start or continue counting down"

	self isRunning: true;
		startStepping.! !

!FtCountDownTimerMorph methodsFor: 'timer' stamp: 'MR 7/17/2007 11:45'!
stop
"stop counting down the time, but do not reset the timer"

	self isRunning: false;
		stopStepping.! !

!FtCountDownTimerMorph methodsFor: 'private' stamp: 'MR 7/17/2007 11:48'!
generateColorTable
"generate a Collection of colors, one color for each state(each possible value of remainingSeconds) of the timer"

	| c1c2 c2c3 neededSteps |
	neededSteps := self secondsToCountDown +1.
	c1c2 := Color green mix: Color yellow shades: (neededSteps/2 + (neededSteps\\2)).
	c2c3 := Color yellow mix: Color red shades: (neededSteps/2).
	
	self colorTable: OrderedCollection new.
	self colorTable addAll: c1c2.
	self colorTable addAll: c2c3.! !

!FtCountDownTimerMorph methodsFor: 'private' stamp: 'MR 7/17/2007 11:49'!
update
"update width and color of the bar"

	| newWidth newColor right |
	newWidth := self fullWidth * self remainingSeconds / self secondsToCountDown.
	newColor := self colorTable at: (self secondsToCountDown - self remainingSeconds +1).
	right := self right.
	
	self width: newWidth;
		right: right;
		color: newColor! !


!FtCountDownTimerMorph class methodsFor: 'class initialization' stamp: 'MR 5/5/2007 14:00'!
withSeconds: aNumberOfSecondsToCountDown

	^ self basicNew initializeWith: aNumberOfSecondsToCountDown! !


!FtGame methodsFor: 'accessing' stamp: 'rkrk 1/20/2008 21:34'!
background
"return a correctly sized form for the background of the game"

	| form scale rect |
	form :=  FtResourceManager at: 'background.jpg'.
	scale := (self neededWidth / form width) max: (self neededHeight / form height).
	form := form magnify: form boundingBox by: scale smoothing: 2.
	rect := Rectangle left: (form width - self neededWidth) right: form width top: 0 bottom: self neededHeight.
	form := form contentsOfArea: rect.
	
	^ form! !

!FtGame methodsFor: 'accessing' stamp: 'MR 7/17/2007 12:08'!
cardField

	^ cardField! !

!FtGame methodsFor: 'accessing' stamp: 'MR 7/17/2007 12:08'!
cardFieldTowersRemoved

	^ cardFieldTowersRemoved! !

!FtGame methodsFor: 'accessing' stamp: 'MR 7/17/2007 12:08'!
depositStack

	^ depositStack! !

!FtGame methodsFor: 'accessing' stamp: 'MR 7/17/2007 12:08'!
drawStack

	^ drawStack! !

!FtGame methodsFor: 'accessing' stamp: 'MR 5/17/2007 21:43'!
gameIsRunning

	^ gameIsRunning! !

!FtGame methodsFor: 'accessing' stamp: 'MR 7/17/2007 12:08'!
scoreCounter

	^ scoreCounter! !

!FtGame methodsFor: 'accessing' stamp: 'MR 7/5/2007 08:42'!
spacing
"distance between the game border and submorphs, and also between the submorphs itself"

	^ 10! !

!FtGame methodsFor: 'accessing' stamp: 'MR 7/17/2007 12:08'!
startButton

	^ startButton! !

!FtGame methodsFor: 'accessing' stamp: 'MR 7/17/2007 12:08'!
stopButton

	^ stopButton! !

!FtGame methodsFor: 'accessing' stamp: 'MR 7/17/2007 12:09'!
timer

	^ timer! !

!FtGame methodsFor: 'accessing - private' stamp: 'MR 7/17/2007 12:10'!
cardFieldTowersRemoved: anInteger

	cardFieldTowersRemoved := anInteger! !

!FtGame methodsFor: 'accessing - private' stamp: 'MR 7/17/2007 12:10'!
cardField: aFtCardFieldMorph

	cardField := aFtCardFieldMorph! !

!FtGame methodsFor: 'accessing - private' stamp: 'MR 7/17/2007 12:11'!
depositStack: aFtCardStackMorph

	depositStack := aFtCardStackMorph! !

!FtGame methodsFor: 'accessing - private' stamp: 'MR 7/17/2007 12:11'!
drawStack: aFtCardDrawStackMorph

	drawStack := aFtCardDrawStackMorph! !

!FtGame methodsFor: 'accessing - private' stamp: 'MR 7/17/2007 12:12'!
gameIsRunning: aBoolean

	gameIsRunning := aBoolean! !

!FtGame methodsFor: 'accessing - private' stamp: 'MR 7/17/2007 12:12'!
scoreCounter: aFtScoreCounterMorph

	scoreCounter := aFtScoreCounterMorph! !

!FtGame methodsFor: 'accessing - private' stamp: 'MR 7/17/2007 12:13'!
startButton: aButtonMorph

	startButton := aButtonMorph! !

!FtGame methodsFor: 'accessing - private' stamp: 'MR 7/17/2007 12:13'!
stopButton: aButtonMorph

	stopButton := aButtonMorph! !

!FtGame methodsFor: 'accessing - private' stamp: 'MR 7/17/2007 12:13'!
timer: aFtCountDownTimerMorph

	timer := aFtCountDownTimerMorph! !

!FtGame methodsFor: 'event handling' stamp: 'MR 6/29/2007 20:32'!
handlesMouseDown: evt

	^ true! !

!FtGame methodsFor: 'event handling' stamp: 'MR 6/29/2007 20:46'!
mouseDown: evt

	self comeToFront.! !

!FtGame methodsFor: 'gameplay' stamp: 'MR 7/17/2007 12:14'!
cardFieldTowerRemoved
"handle the event that a tower was completly removed. if all towers were removed, the game is won"

	self cardFieldTowersRemoved: self cardFieldTowersRemoved + 1.
	
	(self cardFieldTowersRemoved = self cardField numberOfTowers)
	ifTrue: [ self gameWon ]! !

!FtGame methodsFor: 'gameplay' stamp: 'MR 7/17/2007 12:15'!
cardHolderClick: aCardHolder
"handle a click on a card in the field"

	self comeToFront.
	
	(self gameIsRunning) ifFalse: [^ self].
	(aCardHolder holdsCard and: [aCardHolder card showsFront])
	ifTrue: [
		(aCardHolder card isNeighborOf: self depositStack top)
		ifTrue: [
			self depositStack add: aCardHolder removeCard.
			self scoreCounter add: FtGame pointsPerCard.
			(aCardHolder isTop)
			ifTrue: [
				self scoreCounter add: FtGame bonusPointsPerClearedTower.
				self cardFieldTowerRemoved
				]
			]
		].
	(self gameIsRunning)
	ifTrue: [self stopIfWinningIsImpossible]! !

!FtGame methodsFor: 'gameplay' stamp: 'MR 7/17/2007 12:15'!
drawStackClick: aDrawStack
"handle an click on the drawstack"

	self comeToFront.
	
	(aDrawStack isEmpty not and: [self gameIsRunning])
	ifTrue: [
		self depositStack add: aDrawStack top turn.
		].
	self stopIfWinningIsImpossible! !

!FtGame methodsFor: 'gameplay' stamp: 'MR 6/28/2007 16:05'!
gameLose
"handle the event, that the game is lost (timeout or no more possibilities to remove cards)"

	self stopGame.
	
	(MorphicUIManager confirm: 'Sorry, you lost',String cr,'Try again?')
	ifTrue: [self startGame]! !

!FtGame methodsFor: 'gameplay' stamp: 'MR 7/17/2007 12:15'!
gameWon
"handle the event, that the game is won (all towers were removed)"

	self stopGame.
	
	self scoreCounter add: (FtGame bonusPointsPerCardLeftOnStack * self drawStack size).
	self scoreCounter add: (FtGame bonusPointsPerSecondLeft * self timer remainingSeconds).
	
	(MorphicUIManager confirm: 'Congratulations, you won!!',String cr,'Your Score: ', self scoreCounter score asString,String cr,'Play again?')
	ifTrue: [self startGame]! !

!FtGame methodsFor: 'gameplay' stamp: 'MR 7/17/2007 12:15'!
isWinningPossible
"check if it is still possible to win the game, thus check if there are cards left on the drawstack and, if not, check if the card on the deposite stack is neighbor of any card on the field"

	(self drawStack isEmpty) 
	ifFalse: [^ true]
	ifTrue: [
		self cardField cardHoldersWithCardFaceUpDo: 
			[:holder |
			(holder card isNeighborOf: self depositStack top)
			ifTrue: [^ true]
			]
		].
	^ false! !

!FtGame methodsFor: 'gameplay' stamp: 'MR 7/17/2007 12:20'!
startGame
"stop the running game and start a new game"

	(self gameIsRunning) ifTrue: [self stopGame].
	
	self putAllCardsToDrawStack.
	self drawStack shuffle.
	self dealCards;
		cardFieldTowersRemoved: 0.
	self scoreCounter reset.
	
	self gameIsRunning: true.
	self timer resetAndStart! !

!FtGame methodsFor: 'gameplay' stamp: 'MR 7/17/2007 12:22'!
stopGame
"stop the running game"

	self gameIsRunning: false.
	self timer stop! !

!FtGame methodsFor: 'gameplay' stamp: 'JoKer 6/19/2007 17:43'!
stopIfWinningIsImpossible
"stop the game, if it is no longer possible to remove any card from the field"

	(self isWinningPossible)
	ifFalse: [self gameLose]! !

!FtGame methodsFor: 'gameplay' stamp: 'MR 6/9/2007 17:29'!
timerTimeout

	self gameLose.! !

!FtGame methodsFor: 'initialization' stamp: 'MR 7/17/2007 12:23'!
initialize

	super initialize.
	
	self initSubmorphs;
		newForm: self background;
		posSubmorphs;
		addCardsToDrawStack;
		gameIsRunning: false.! !

!FtGame methodsFor: 'initialization' stamp: 'MR 6/28/2007 17:47'!
initializeToStandAlone

	self initialize! !

!FtGame methodsFor: 'private' stamp: 'MR 7/17/2007 12:23'!
addCardsToDrawStack

	FtGame cards do: [:each | | newCard |
		newCard := FtCardMorph withValue: (each at: #value) color: (each at: #color).
		self drawStack add: newCard
		].! !

!FtGame methodsFor: 'private' stamp: 'MR 7/17/2007 12:24'!
dealCards

	self cardField cardHoldersDo: [:each |
		each addCard: self drawStack top.
		].
	self cardField cardHoldersDo: [:each |
		each setCardSide.
		].
	
	self depositStack addMorphCentered: self drawStack top turn.! !

!FtGame methodsFor: 'private' stamp: 'rkrk 1/20/2008 21:34'!
initSubmorphs
"create the submorphs and add them"

	| startPicturePressed startPictureOnOff stopPictureOnOff stopPicturePressed |
	self cardField: (FtCardFieldMorph with: FtGame cardFieldLayout);
		drawStack: FtCardDrawStackMorph new;
		depositStack: FtCardStackMorph new.
	
	startPictureOnOff := FtResourceManager at: 'arrow_off.jpg'.
	startPicturePressed := FtResourceManager at: 'arrow_press.jpg'.
	self startButton: 
		(ThreePhaseButtonMorph new
		offImage: startPictureOnOff;
		onImage: startPictureOnOff;
		pressedImage: startPicturePressed;
		target: self;
		actionSelector: #startGame;
		extent: startPictureOnOff extent).
		
	stopPictureOnOff  := FtResourceManager at: 'cross_off.jpg'.
	stopPicturePressed := FtResourceManager at: 'cross_press.jpg'.
	self stopButton: 
		(ThreePhaseButtonMorph new
		offImage: stopPictureOnOff;
		onImage: stopPictureOnOff;
		pressedImage: stopPicturePressed;
		target: self;
		actionSelector: #dismissMorph;
		extent: stopPictureOnOff extent).
		
	self scoreCounter: FtScoreCountMorph new.
	self timer: (FtCountDownTimerMorph withSeconds: FtGame secondsPerGame).
	self timer fullWidth: (cardField width max: (FtGame minWidth - (2 * self spacing))).
	
	self 
		addMorph: self cardField;
		addMorph: self drawStack;
		addMorph: self depositStack;
		addMorph: self startButton;
		addMorph: self stopButton;
		addMorph: self scoreCounter;
		addMorph: self timer.! !

!FtGame methodsFor: 'private' stamp: 'MR 7/17/2007 12:28'!
neededHeight
"return the height needed for the game morph (objects height + spacing)"

	| d |
	d := self spacing.
	
	^ (	d +
		self cardField height +
		d + 
		self timer height +
		d + 
		self drawStack height + (self drawStack cardDisplacement * FtGame cards size) +
		d )! !

!FtGame methodsFor: 'private' stamp: 'MR 7/17/2007 12:28'!
neededWidth
"return the width needed for the game morph (objects width + spacing)"

	| d |
	d := self spacing.
	
	^ (d + self cardField width + d) max: (FtGame minWidth)! !

!FtGame methodsFor: 'private' stamp: 'MR 7/17/2007 12:29'!
posSubmorphs
"position the submorphs"

	| d |
	d := self spacing.
	
	self cardField topLeft: (((self width - self cardField width)/2 + self left) @ d).
	self timer topLeft: (((self width - self timer width)/2 + self left) @ (self cardField bottom + d)).
	self drawStack bottomRight: (self bottomCenter - (d @ d)).
	self depositStack bottomLeft: (self bottomCenter + (d @ d negated)).
	self startButton bottomRight: (self bottomRight - (d @ d) - (0 @ self stopButton height + d)).
	self stopButton topLeft: (self startButton bottomLeft + ((self startButton width - self stopButton width)/2 @ d)).
	self scoreCounter bottomLeft: self bottomLeft + (d @ d negated).! !

!FtGame methodsFor: 'private' stamp: 'MR 7/17/2007 12:30'!
putAllCardsToDrawStack
"put all cards back to the drawstack"

	[self depositStack isEmpty] whileFalse: [self drawStack add: self depositStack top turnToBack].
	
	self cardField cardHoldersDo: [:each |
		(each holdsCard) 
		ifTrue: [self drawStack add: each card turnToBack]
		].
	! !


!FtGame class methodsFor: 'Constants' stamp: 'MR 6/28/2007 16:00'!
bonusPointsPerCardLeftOnStack
"number of points you get for every card left on the stack, when you won"

	^ 5! !

!FtGame class methodsFor: 'Constants' stamp: 'MR 6/28/2007 16:01'!
bonusPointsPerClearedTower
"number of points you get for cleaning a tower completly"

	^ 50! !

!FtGame class methodsFor: 'Constants' stamp: 'MR 6/28/2007 16:01'!
bonusPointsPerSecondLeft
"number of points you get for every card left on the stack, when you won"

	^ 5! !

!FtGame class methodsFor: 'Constants' stamp: 'MR 7/4/2007 15:06'!
cardColors
"possible card colors"

	"^ #('Clubs' 'Spades' 'Hearts' 'Diamonds')"
	^ #('fire' 'water' 'air' 'ground')! !

!FtGame class methodsFor: 'Constants' stamp: 'MR 7/4/2007 15:06'!
cardFieldLayout
"define how the cards are placed. 1 marks places with CardHolders, 0-marked places will be nil"

	^ #(    (1 0 0 1 0 0 1)
		   (1 1 0 1 1 0 1 1)
		  (1 1 1 1 1 1 1 1 1)
		 (1 1 1 1 1 1 1 1 1 1) )! !

!FtGame class methodsFor: 'Constants' stamp: 'rkrk 1/20/2008 21:33'!
cardHeight
"Height of a card in pixels"

	^ (FtResourceManager at: 'card_back.jpg') height! !

!FtGame class methodsFor: 'Constants' stamp: 'MR 7/4/2007 14:37'!
cards
"return a collection of all possible cards (values x colors)"

	| result i |
	result := Array new: (self cardColors size * self cardValues size).
	i := 1.
	self cardColors do: [:c |
		self cardValues do: [:v |
			result at: i put: (Dictionary newFrom: {#color -> c. #value -> v}).
			i := i + 1.
			]
		].
	^ result.! !

!FtGame class methodsFor: 'Constants' stamp: 'MR 7/4/2007 15:06'!
cardValues
"possible card values"

	"^ #('2' '3' '4' '5' '6' '7' '8' '9' '10' 'J' 'Q' 'K' 'A')"
	^ #('1' '2' '3' '4' '5' '6' '7' '8' '9' '10' '11' '12' '13')! !

!FtGame class methodsFor: 'Constants' stamp: 'MR 6/28/2007 16:01'!
cardValuesAntecessores
"define anrecessors for the card values defined in 'cardValues'"

	^ #('13' '1' '2' '3' '4' '5' '6' '7' '8' '9' '10' '11' '12')! !

!FtGame class methodsFor: 'Constants' stamp: 'MR 6/28/2007 16:01'!
cardValuesSuccessores
"define successors for the card values defined in 'cardValues'"

	^ #('2' '3' '4' '5' '6' '7' '8' '9' '10' '11' '12' '13' '1')! !

!FtGame class methodsFor: 'Constants' stamp: 'rkrk 1/20/2008 21:33'!
cardWidth
"Width of a card in pixels"

	^ (FtResourceManager at: 'card_back.jpg') width! !

!FtGame class methodsFor: 'Constants' stamp: 'MR 7/1/2007 17:23'!
minWidth

	^ 500! !

!FtGame class methodsFor: 'Constants' stamp: 'MR 6/28/2007 16:01'!
pointsPerCard
"points you get for removing one card from the field"

	^ 10! !

!FtGame class methodsFor: 'Constants' stamp: 'MR 6/28/2007 16:01'!
ressourcesPath
"path to the ressources-directory from funtowers"

	^ 'ftressource', FileDirectory slash.! !

!FtGame class methodsFor: 'Constants' stamp: 'MR 6/28/2007 16:01'!
secondsPerGame
"the time you have for solving the game"

	^ 90! !

!FtGame class methodsFor: 'instance creation' stamp: 'MR 6/28/2007 16:01'!
create
"create a new instace of the game for playing"

	self new openInHand! !

!FtGame class methodsFor: 'parts bin' stamp: 'rkrk 1/20/2008 21:32'!
descriptionForPartsBin

	^ self
		partName: 'Funtowers'
		categories: #('Games')
		documentation: 'A nice singleplayer card game.'! !


!FtResourceManager methodsFor: 'accessing' stamp: 'MR 7/17/2007 11:56'!
at: filename
"return the resource with the given filename"

	(self resources includesKey: filename)
	ifFalse: [self error: 'resource ',filename,' is not available'].
	
	^ self resources at: filename! !

!FtResourceManager methodsFor: 'accessing' stamp: 'MR 7/17/2007 11:55'!
resources

	^ resources! !

!FtResourceManager methodsFor: 'accessing' stamp: 'MR 7/17/2007 11:56'!
resources: aDictionary

	resources := aDictionary! !

!FtResourceManager methodsFor: 'initialization' stamp: 'MR 7/17/2007 11:57'!
initialize

	super initialize.
	
	self resources: Dictionary new;
		loadImages.! !

!FtResourceManager methodsFor: 'initialization' stamp: 'rkrk 1/20/2008 21:32'!
loadImages

	| resdir imageFiles dirPath |
	dirPath := SmalltalkImage current imagePath , FileDirectory slash , FtGame ressourcesPath.
	resdir := FileDirectory on: dirPath.
	"imageFiles := resdir fileNamesMatching: '*.gif;*.jpg;*.jpeg;*.png'."
	imageFiles := resdir fileNamesMatching: '*.jpg'.
	
	imageFiles do: [:each | | form |
		(FtResourceManager excludelist includes: each)
		ifFalse: [
			form := Form fromFileNamed: dirPath , each.
			self resources add: (each -> form)
			]
		]! !


!FtResourceManager class methodsFor: 'accessing' stamp: 'MR 7/14/2007 17:34'!
at: filename
"return the resource with the given filename"

	^ SoleInstance at: filename! !

!FtResourceManager class methodsFor: 'accessing' stamp: 'MR 6/30/2007 23:52'!
excludelist
"collection of files that should be excluded from loading"

	^ #('icon.gif')! !

!FtResourceManager class methodsFor: 'instance creation' stamp: 'MR 7/14/2007 17:33'!
new

	self shouldNotImplement! !

!FtResourceManager class methodsFor: 'class initialization' stamp: 'MR 7/14/2007 17:35'!
initialize

	SoleInstance _ self basicNew initialize! !


!FtScoreCountMorph methodsFor: 'accessing' stamp: 'MR 7/17/2007 11:59'!
add: anInteger
"add the given number of points to the score"

	self score: self score + anInteger.
	self update! !

!FtScoreCountMorph methodsFor: 'accessing' stamp: 'MR 7/17/2007 11:59'!
reset

	self score: 0.
	self update.! !

!FtScoreCountMorph methodsFor: 'accessing' stamp: 'MR 5/26/2007 11:42'!
score

	^ score! !

!FtScoreCountMorph methodsFor: 'accessing - private' stamp: 'MR 7/17/2007 11:59'!
score: anInteger

	score := anInteger! !

!FtScoreCountMorph methodsFor: 'initialization' stamp: 'MR 7/17/2007 12:00'!
initialize

	super initialize.

	self score: 0;
		font: (TTCFont familyName: 'BitstreamVeraSans' pointSize: 20 emphasis: 3);
		update! !

!FtScoreCountMorph methodsFor: 'private' stamp: 'MR 7/17/2007 12:00'!
update

	self contents: 'Score: ', self score asString! !

FtResourceManager initialize!
